//|                                         OutsideBar TrendLine.mq4 |

// Thread : http://www.forexfactory.com/showthread.php?t=431623&page=2
// Original Idea : recidiviste
// Coder : pickers
// dated : 10 Jun 2013.

extern bool    AlertText               = false;
extern bool    PrintText               = false;
extern int     ClearancePips           = 5;
extern int     LookBackBars            = 500;
extern color   OutSideBarColor         = Magenta;
extern color   InSideBarColor          = GreenYellow;
extern color   OutSideBarGOLD          = Gold;
extern bool    OriginalTrigger         = true;
extern bool    ShowDailyPivot          = false;
extern int     OutSideExtend           = 0;

int         Time_1                  = 0;                    //NewBar1() - 
string      Signal_Bar1             = "Close";              //NewBar1()
bool        NewBarSignal1           = false;                //NewBar1() 

int         Time_2                  = 0;                    //NewBar2() - 
string      Signal_Bar2             = "Close";              //NewBar2()
bool        NewBarSignal2           = false;                //NewBar2() 

bool        Restart                 = true;                 

double      BuyTrendLine            = 0;
double      SellTrendLine           = 0;
string      LastTrigger             = "x";
double      TPoints                 = 0;
double      LastBidPrice            = 0;
double      LatestOBHigh            = 999999;
double      LatestOBLow             = 0;

void init()
   {
      ObjectsDeleteAll();
      if (Digits == 3 || Digits == 5)
         {  
            TPoints = Point * 10;
         }
      if (Digits == 2 || Digits == 4)
         {  
            TPoints = Point;
         }
      OutsideBarProcessPast();
      if ( ShowDailyPivot )
            DailyPivot();
      Restart              = false;
   }
void start()
   {
      NewBar1();
      NewBar2();
      if ( NewBarSignal1 )
         OutsideBarProcess();
      if ( ShowDailyPivot && NewBarSignal2) // daily
            DailyPivot();
         
      Signal_Bar1          = "Close";
      Signal_Bar2          = "Close";
      
      if ( OriginalTrigger && LastBidPrice != 0) // Original as in first version
         {
            if ( Bid > BuyTrendLine + ClearancePips * TPoints && LastBidPrice < BuyTrendLine + ClearancePips * TPoints && LastTrigger != "Buy")
               {
                  LastTrigger = "Buy";
                  string BuyText = " Buy!!!! "+Symbol()+" at "+Bid+" > "+BuyTrendLine+"  . Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                  if ( PrintText )
                        Print ( BuyText);
                  if ( AlertText)
                        Alert( BuyText);
               }
            if ( Bid < SellTrendLine - ClearancePips * TPoints && LastBidPrice > SellTrendLine - ClearancePips * TPoints   && LastTrigger != "Sell")
               {
                  LastTrigger = "Sell";
         
                  string SellText = " Sell!!!! "+Symbol()+" at "+Bid+" < "+SellTrendLine+". Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                  if ( PrintText )
                        Print ( SellText);
                  if ( AlertText)
                        Alert( SellText);
               }
         }
      if ( OriginalTrigger == false && LastBidPrice != 0 ) // pickers 's style
         {
            if ( MathAbs(BuyTrendLine - SellTrendLine) > 20 * TPoints )
               {
                  if ( LastTrigger != "Buy" )
                     { 
                        if (  ( Bid > BuyTrendLine    + ClearancePips * TPoints && LastBidPrice <  BuyTrendLine   + ClearancePips * TPoints )
                           || ( Bid > SellTrendLine   + ClearancePips * TPoints && LastBidPrice <  SellTrendLine  + ClearancePips * TPoints ) )
                           {
                              LastTrigger = "Buy";
                              BuyText = " Buy!!!! "+Symbol()+" at "+Bid+" > "+BuyTrendLine+"  . Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                              if ( PrintText )
                                    Print ( BuyText);
                              if ( AlertText)
                                    Alert( BuyText);
                           }
                     }
                  if ( LastTrigger != "Sell")
                     {
                        if (  ( Bid < SellTrendLine   - ClearancePips * TPoints && LastBidPrice >  SellTrendLine  - ClearancePips * TPoints )
                           || ( Bid < BuyTrendLine    - ClearancePips * TPoints && LastBidPrice >  BuyTrendLine   - ClearancePips * TPoints ) )
                           {
                              LastTrigger = "Sell";
         
                              SellText = " Sell!!!! "+Symbol()+" at "+Bid+" < "+SellTrendLine+". Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                              if ( PrintText )
                                    Print ( SellText);
                              if ( AlertText)
                                    Alert( SellText);
                           }
                     }
               }
            if ( MathAbs(BuyTrendLine - SellTrendLine) < 20 * TPoints )
               {
                  if ( LastTrigger != "Buy" )
                     { 
                        if (  ( Bid > BuyTrendLine    + ClearancePips * TPoints && LastBidPrice <  BuyTrendLine   + ClearancePips * TPoints && BuyTrendLine > SellTrendLine)
                           || ( Bid > SellTrendLine   + ClearancePips * TPoints && LastBidPrice >  SellTrendLine  + ClearancePips * TPoints && SellTrendLine > BuyTrendLine) )
                           {
                              LastTrigger = "Buy";
                              BuyText = " Buy!!!! "+Symbol()+" at "+Bid+" > "+BuyTrendLine+"  . Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                              if ( PrintText )
                                    Print ( BuyText);
                              if ( AlertText)
                                    Alert( BuyText);
                           }
                     }
                  if ( LastTrigger != "Sell")
                     {
                        if (  ( Bid < SellTrendLine   - ClearancePips * TPoints && LastBidPrice >  SellTrendLine  - ClearancePips * TPoints && SellTrendLine < BuyTrendLine)
                           || ( Bid < BuyTrendLine    - ClearancePips * TPoints && LastBidPrice >  BuyTrendLine   - ClearancePips * TPoints && BuyTrendLine < SellTrendLine) )
                           {
                              LastTrigger = "Sell";
         
                              SellText = " Sell!!!! "+Symbol()+" at "+Bid+" < "+SellTrendLine+". Time Mins("+TimeMinute(TimeCurrent()) + ") : Hrs("+ TimeHour(TimeCurrent())+") : Day("+TimeDay(TimeCurrent())+")";
                              if ( PrintText )
                                    Print ( SellText);
                              if ( AlertText)
                                    Alert( SellText);
                           }
                     }
               }
         }
      LastBidPrice = Bid;
   }
  
void OutsideBarProcess()
   {
      double Higharray[3];
      double Lowarray[3];
      int HighBararray[3];
      int LowBararray[3];
      BuyTrendLine         = 0;
      SellTrendLine        = 0;
      LastTrigger          = "x"; // at a new bar the LastTrigger will clear to allow another similar entry, instead of restricting at buy==>sell==>buy etc.
      
      for ( int z = 0; z <=2; z++) // zerolisation.
         {
            Higharray[z]      = 0;
            Lowarray[z]       = 0;
            HighBararray[z]   = 0;
            LowBararray[z]    = 0;
         }
      
      bool outsidebar   = false;
      bool insidebar    = false;
      int OutSideCount  = 0;
      for (int a = 1; a<=LookBackBars; a++)
         {
            outsidebar  = false;
            insidebar   = false;
            double HighCurrent      = iHigh(Symbol(),Period(),a);
            double LowCurrent       = iLow(Symbol(),Period(),a);
            double HighPast         = iHigh(Symbol(),Period(),a+1);
            double LowPast          = iLow(Symbol(),Period(),a+1);
            if ( HighCurrent > HighPast && LowCurrent < LowPast )
                  outsidebar  = true;
            if ( HighCurrent < HighPast && LowCurrent > LowPast )
                  insidebar   = true;
            if ( outsidebar )
                  OutSideCount++;
            if ( outsidebar && Higharray[1] != 0 && Higharray[2] == 0 && OutSideCount > OutSideExtend  )
               {
                  if ( HighCurrent > Higharray[1] )
                     {
                        HighBararray[2]   = a;
                        Higharray[2]      = HighCurrent ;
                     }
               }
            if ( outsidebar && Lowarray[1] != 0 && Lowarray[2] == 0 && OutSideCount > OutSideExtend  )
               {
                  if ( LowCurrent < Lowarray[1] )
                     {
                        LowBararray[2]    = a;
                        Lowarray[2]       = LowCurrent ;
                     }
               }
            if ( outsidebar && Higharray[1] == 0)
               {
                  Higharray[1]            = HighCurrent ;
                  HighBararray[1]         = a;
                  Lowarray[1]             = LowCurrent ;
                  LowBararray[1]          = a;
               }
            if ( outsidebar ) // draw outsidebar
               {
                  string OutSideBarNo = "OutSideBarNo"+iTime(Symbol(),Period(),a);
                  ObjectDelete(OutSideBarNo);
                  TargetLine(OutSideBarNo,  Time[a], HighCurrent,  Time[a], LowCurrent,OutSideBarColor);
               }
            if ( insidebar ) // draw insidebar
               {
                  string InSideBarNo = "InSideBarNo"+iTime(Symbol(),Period(),a);
                  ObjectDelete(InSideBarNo);
                  TargetLine(InSideBarNo,  Time[a], HighCurrent,  Time[a], LowCurrent,InSideBarColor);
               }
            if ( Higharray[2] != 0 && Lowarray[2] != 0 && !Restart)
                  break;
            
         }
            
      double BuyTrendIncre       = (Higharray[2] - Higharray[1] ) / (HighBararray[2] - HighBararray[1]);
      double SellTrendIncre      = (Lowarray[1] - Lowarray[2] ) / (LowBararray[2] - LowBararray[1]);
      BuyTrendLine        = Higharray[2];
      SellTrendLine       = Lowarray[2];

      if ( Higharray[2] == 0) // in the event when there is no past Higher high. therefore drawing a horizontal line instead.
         {
            Higharray[2]      = Higharray[1];
            HighBararray[2]   = HighBararray[1];
            BuyTrendLine      = Higharray[2];
            BuyTrendIncre     = 0;
         }
      if ( Lowarray[2] == 0) 
         {
            Lowarray[2]      = Lowarray[1];
            LowBararray[2]   = LowBararray[1];
            SellTrendLine    = Lowarray[2];
            SellTrendIncre   = 0;
         }            

      for (int b = HighBararray[2] -1; b>=0 ; b--)
         {
            BuyTrendLine = BuyTrendLine - BuyTrendIncre ;
         }
      for (b = LowBararray[2] -1; b>=0 ; b--)
         {
            SellTrendLine = SellTrendLine + SellTrendIncre ;
         }
      ObjectDelete("BuyTrendVisual");
      TargetLine("BuyTrendVisual",  Time[0], BuyTrendLine,  Time[HighBararray[2]], Higharray[2],SkyBlue);
      ObjectDelete("SellTrendVisual");
      TargetLine("SellTrendVisual",  Time[0], SellTrendLine,  Time[LowBararray[2]], Lowarray[2],LightSalmon);

      double BuyTrendDiff     = MathAbs(BuyTrendLine - Higharray[2])/TPoints;
      if ( BuyTrendDiff < 1 )
            BuyTrendDiff = 1;
      double SellTrendDiff    = MathAbs(SellTrendLine - Lowarray[2])/TPoints;
      if ( SellTrendDiff < 1)
            SellTrendDiff = 1;
      int PowerBuyTrend       = iBarShift(Symbol(),1,iTime(Symbol(),Period(),HighBararray[2]),false)/ BuyTrendDiff ;
      int PowerSellTrend      = iBarShift(Symbol(),1,iTime(Symbol(),Period(),LowBararray[2]),false) / SellTrendDiff ;

      string PowerBuyTrendTxt          = DoubleToStr(PowerBuyTrend,0);
      string PowerSellTrendTxt         = DoubleToStr(PowerSellTrend,0);
      double PowerBuyDisplayPrice      = BuyTrendLine + 15*TPoints;
      double PowerSellDisplayPrice     = SellTrendLine + 15*TPoints;
      if ( PowerBuyDisplayPrice < PowerSellDisplayPrice + 15*TPoints && PowerBuyDisplayPrice > PowerSellDisplayPrice - 15*TPoints )
            PowerSellDisplayPrice      = PowerSellDisplayPrice - 15*TPoints;
      ObjectDelete("PowerBuyTrend");
      ObjectCreate("PowerBuyTrend", OBJ_TEXT, 0, Time[0], PowerBuyDisplayPrice);
      ObjectSetText("PowerBuyTrend","                       ---- > "+PowerBuyTrend , 10, "Verdana", SkyBlue);
      ObjectDelete("PowerSellTrend");
      ObjectCreate("PowerSellTrend", OBJ_TEXT, 0, Time[0], PowerSellDisplayPrice);
      ObjectSetText("PowerSellTrend","                      ---- > "+PowerSellTrend , 10, "Verdana", LightSalmon);

      if ( LatestOBHigh != Higharray[1] )
         {
            LatestOBHigh   = Higharray[1];
            LatestOBLow    = Lowarray[1]; 
            if ( !Restart)
                  OutsideBarProcessPast();
         }
   }

void OutsideBarProcessPast()
   {
      double Higharray[3];
      double Lowarray[3];
      int HighBararray[3];
      int LowBararray[3];
      BuyTrendLine         = 0;
      SellTrendLine        = 0;
      LastTrigger          = "x"; // at a new bar the LastTrigger will clear to allow another similar entry, instead of restricting at buy==>sell==>buy etc.
      
      for ( int z = 0; z <=2; z++) // zerolisation.
         {
            Higharray[z]      = 0;
            Lowarray[z]       = 0;
            HighBararray[z]   = 0;
            LowBararray[z]    = 0;
         }
      
      bool outsidebar   = false;
      bool insidebar    = false;
      int LastOutSideBar1 = 0;
      int LastOutSideBar2 = 0;
      for (int a = 1; a<=LookBackBars; a++)
         {
            outsidebar   = false;
            insidebar    = false;
            datetime BarTime        = iTime(Symbol(),Period(),a);
            double HighCurrent      = iHigh(Symbol(),Period(),a);
            double LowCurrent       = iLow(Symbol(),Period(),a);
            double HighPast         = iHigh(Symbol(),Period(),a+1);
            double LowPast          = iLow(Symbol(),Period(),a+1);
            if ( HighCurrent > HighPast && LowCurrent < LowPast )
                  outsidebar  = true;
            if ( HighCurrent < HighPast && LowCurrent > LowPast )
                  insidebar   = true;
            if ( insidebar ) //draw inside bar
               {
                  string InSideBarNo = "InSideBarNo"+BarTime;
                  ObjectDelete(InSideBarNo);
                  TargetLine(InSideBarNo,  Time[a], HighCurrent,  Time[a], LowCurrent,InSideBarColor);
               }
            if ( outsidebar ) // draw outsidebar
               {
                  string OutSideBarNo     = "OutSideBarNo"+BarTime;
                  ObjectDelete(OutSideBarNo);
                  int DailyBarShift       = iBarShift(Symbol(),1440,BarTime,false);

                  color BarColor          = OutSideBarColor;
                  if ( HighCurrent == iHigh(Symbol(),1440,DailyBarShift) || LowCurrent == iLow(Symbol(),1440,DailyBarShift) )
                        BarColor          = OutSideBarGOLD;
                  TargetLine(OutSideBarNo,  Time[a], HighCurrent,  Time[a], LowCurrent,BarColor);
                  if ( LastOutSideBar1  != a )
                     {
                        LastOutSideBar2 = LastOutSideBar1;
                        LastOutSideBar1 = a;
                     }
               }
            if ( outsidebar  )
               {
                  //check Buy trendline
                  Higharray[1]   = 0;
                  Higharray[2]   = 0;
                  int OutSideHighExtend = OutSideExtend;
                  int OutSideHighCount  = 0;
                  for (int b = a; b<=a+LookBackBars; b++)
                     {
                        outsidebar  = false;
                        HighCurrent      = iHigh(Symbol(),Period(),b);
                        LowCurrent       = iLow(Symbol(),Period(),b);
                        HighPast         = iHigh(Symbol(),Period(),b+1);
                        LowPast          = iLow(Symbol(),Period(),b+1);
                        if ( HighCurrent > HighPast && LowCurrent < LowPast )
                              outsidebar  = true;
                        if ( outsidebar  )
                              OutSideHighCount++;
                        if ( outsidebar && Higharray[1] != 0 && Higharray[2] == 0 && OutSideHighCount > OutSideHighExtend  )
                           {
                              if ( HighCurrent > Higharray[1] )
                                 {
                                    HighBararray[2]   = b;
                                    Higharray[2]      = HighCurrent ;
                                 }
                           }
                        if ( outsidebar && Higharray[1] == 0)
                           {
                              Higharray[1]            = HighCurrent ;
                              HighBararray[1]         = b;
                           }
                        if ( Higharray[2] != 0 )
                           {
                              double BuyTrendIncre       = (Higharray[2] - Higharray[1] ) / (HighBararray[2] - HighBararray[1]);
                              BuyTrendLine               = Higharray[1];
                              for (int c = HighBararray[1] -1; c>=LastOutSideBar2; c--)
                                 {
                                    BuyTrendLine = BuyTrendLine - BuyTrendIncre ;
                                 }
                              string BuyTrendLookBack = "BuyTrendLookBack" + Time[HighBararray[1]];
                              ObjectDelete(BuyTrendLookBack);
                              PastTargetLine(BuyTrendLookBack,  Time[LastOutSideBar2], BuyTrendLine,  Time[HighBararray[1]], Higharray[1],LightSkyBlue);
                              
                              Higharray[2]      = 0;
                              Higharray[1]      = 0;
                              break;
                           }
                        if ( b == a+LookBackBars)
                           {
                              if ( Higharray[2] == 0) // in the event when there is no past Higher high. therefore drawing a horizontal line instead.
                                 {
                                    Higharray[2]         = Higharray[1];
                                    HighBararray[2]      = HighBararray[1];
                                    BuyTrendLine         = Higharray[2];
                                    BuyTrendIncre        = 0;

                                    BuyTrendLookBack = "BuyTrendLookBack" + Time[HighBararray[1]];
                                    ObjectDelete(BuyTrendLookBack);
                                    PastTargetLine(BuyTrendLookBack,  Time[LastOutSideBar2], BuyTrendLine,  Time[HighBararray[1]], Higharray[1],LightSkyBlue);
                              
                                    Higharray[2]      = 0;
                                    Higharray[1]      = 0;
                                 }
                           }
                     }
                  //check Sell trendline
                  Lowarray[1]    = 0;
                  Lowarray[2]    = 0;
                  int OutSideLowExtend = OutSideExtend;
                  int OutSideLowCount  = 0;
                  for (b = a; b<=a+LookBackBars; b++)
                     {
                        outsidebar        = false;
                        HighCurrent       = iHigh(Symbol(),Period(),b);
                        LowCurrent        = iLow(Symbol(),Period(),b);
                        HighPast          = iHigh(Symbol(),Period(),b+1);
                        LowPast           = iLow(Symbol(),Period(),b+1);
                        if ( HighCurrent > HighPast && LowCurrent < LowPast )
                              outsidebar  = true;
                        if (outsidebar)
                              OutSideLowCount++;
                        if ( outsidebar && Lowarray[1] != 0 && Lowarray[2] == 0 && OutSideLowCount > OutSideLowExtend)
                           {
                              if ( LowCurrent < Lowarray[1] )
                                 {
                                    LowBararray[2]    = b;
                                    Lowarray[2]       = LowCurrent ;
                                 }
                           }
                        if ( outsidebar && Lowarray[1] == 0)
                           {
                              Lowarray[1]             = LowCurrent ;
                              LowBararray[1]          = b;
                           }
                        if ( Lowarray[2] != 0) 
                           {
                              
                              double SellTrendIncre      = (Lowarray[1] - Lowarray[2] ) / (LowBararray[2] - LowBararray[1]);
                              SellTrendLine              = Lowarray[1];
                              for (c = LowBararray[1] -1; c>=LastOutSideBar2 ; c--)
                                 {
                                    SellTrendLine = SellTrendLine + SellTrendIncre ;
                                 }
                              string SellTrendLookBack = "SellTrendLookBack" + Time[LowBararray[1]];
                              ObjectDelete(SellTrendLookBack);
                              PastTargetLine(SellTrendLookBack ,  Time[LastOutSideBar2], SellTrendLine,  Time[LowBararray[1]], Lowarray[1],LightSalmon);

                              Lowarray[2]       = 0;
                              Lowarray[1]       = 0;
                           }
                        if ( b == a+LookBackBars)
                           {
                              if ( Lowarray[2] == 0) 
                                 {
                                    Lowarray[2]          = Lowarray[1];
                                    LowBararray[2]       = LowBararray[1];
                                    SellTrendLine        = Lowarray[2];
                                    SellTrendIncre       = 0;
                                    
                                    SellTrendLookBack = "SellTrendLookBack" + Time[LowBararray[1]];
                                    ObjectDelete(SellTrendLookBack);
                                    PastTargetLine(SellTrendLookBack ,  Time[LastOutSideBar2], SellTrendLine,  Time[LowBararray[1]], Lowarray[1],LightSalmon);
                                    
                                    Lowarray[2]       = 0;
                                    Lowarray[1]       = 0;
                                 }            
                           }
                     }
               }
         }
//      ObjectDelete("BuyTrendVisual");
//      TargetLine("BuyTrendVisual",  Time[0], BuyTrendLine,  Time[HighBararray[2]], Higharray[2],SkyBlue);
//      ObjectDelete("SellTrendVisual");
//      TargetLine("SellTrendVisual",  Time[0], SellTrendLine,  Time[LowBararray[2]], Lowarray[2],LightSalmon);
   }

void DailyPivot()
   {
//       Pivot calculation
//       Resistance Level 3   = (Pivot Point - Support Level 2) + Resistance Level 2
//       Resistance Level 2   = (Pivot Point - Support Level 1) + Resistance Level 1
//       Resistance Level 1   = (2 * Pivot Point) - Previous Low
//       Pivot Point          = (Previous High + Previous Low + Previous Close) / 3
//       Support Level 1      = (2 * Pivot Point) - Previous High
//       Support Level 2      = Pivot Point - (Resistance Level 1 - Support Level 1)
//       Support Level 3      = Pivot Point - (Resistance Level 2 - Support Level 2)

//       Resistance Level 3   = (1.98516 - 1.95432) + 2.016          = 2.04684
//       Resistance Level 2   = (1.98516 - 1.9673) + 1.99814         = 2.016 
//       Resistance Level 1   = (2 * 1.98516) - 1.97218              = 1.99814
//       Pivot Point          = (2.00302+ 1.97218+ 1.98027) / 3      = 1.98516
//       Support Level 1      = (2 * 1.98516) - 2.00302              = 1.9673
//       Support Level 2      = 1.98516 - (1.99814 - 1.9673)         = 1.95432
//       Support Level 3      = 1.98516 - (2.016 - 1.95432)          = 1.92348

//       Balance Point Calculation
//       Level E              = C + (H-L)                            = 2.016     // same as resistance level 2
//       Level D              = C + (H-L)/2                          = 2.00058
//       Level C              = (H + L + C) / 3                      = 1.98516
//       Level B              = C - (H-L)/2                          = 1.96974
//       Level A              = C - (H-L)                            = 1.95432   // same as support level 2
   }

void PastTargetLine(string name, datetime TimeA, double PriceA, datetime TimeB, double PriceB, color LineColor)
   {
      ObjectDelete(name);
      ObjectCreate(name, OBJ_TREND , 0, TimeA, PriceA, TimeB, PriceB);
      ObjectSet(name,OBJPROP_COLOR, LineColor);
      ObjectSet(name,OBJPROP_STYLE, STYLE_DOT);
      ObjectSet (name, OBJPROP_RAY,0);
      ObjectSet (name, OBJPROP_WIDTH,1);
   } 

void TargetLine(string name, datetime TimeA, double PriceA, datetime TimeB, double PriceB, color LineColor)
   {
      ObjectDelete(name);
      ObjectCreate(name, OBJ_TREND , 0, TimeA, PriceA, TimeB, PriceB);
      ObjectSet(name,OBJPROP_COLOR, LineColor);
      ObjectSet(name,OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet (name, OBJPROP_RAY,0);
      ObjectSet (name, OBJPROP_WIDTH,3);
   } 

void NewBar1()  // Current Window TimeFrame
   {
      int TimeType = Period();
      if ( Signal_Bar1 == "Close") 
         {
            if ( Time_1    < iTime ( 0 , TimeType , 0 ) )
               { 
                  Time_1   = iTime ( 0 , TimeType , 0 ) ; 
                  NewBarSignal1 = true;
                  Signal_Bar1 = "Open"; 
               }
            else     
               {
                  NewBarSignal1 = false; 
               }
         }
   }

void NewBar2()  // daily
   {
      int TimeType = 1440;
      if ( Signal_Bar2 == "Close") 
         {
            if ( Time_2    < iTime ( 0 , TimeType , 0 ) )
               { 
                  Time_2   = iTime ( 0 , TimeType , 0 ) ; 
                  NewBarSignal2 = true;
                  Signal_Bar2 = "Open"; 
               }
            else     
               {
                  NewBarSignal2 = false; 
               }
         }
   }


void deinit()
  {
  }